%define debug_package %{nil}
%define product_family Springdale Open Enterprise Linux
%define product_family_rhel Red Hat Enterprise Linux
%define release_name Parma
%define release_name_rhel Plow
%define base_release_version 9
%define full_release_version 9.0
%define dist_release_version 9
# When moving from Beta to GA, the beta definition needs to be removed,
# not just commented out.
%define beta Beta
%define beta_part %{?beta:-%{beta}}
#define swid_regid redhat.com
%define dist .el%{dist_release_version}

Name:           springdale-release
Version:        %{full_release_version}
Release:        0.16.sdl9
Summary:        %{product_family} release file
Group:          System Environment/Base
License:        GPLv2
Provides:       redhat-release = %{version}-%{release}
Provides:       system-release = %{version}-%{release}
Provides:       system-release(releasever) = %{base_release_version}
Provides:       base-module(platform:el%{base_release_version})
Provides:       redhat-release-server
Provides:       redhat-release-client
Provides:       redhat-release-computenode
Provides:       redhat-release-workstation
Obsoletes:      redhat-release
Obsoletes:      redhat-release-server
Obsoletes:      redhat-release-client
Obsoletes:      redhat-release-computenode
Obsoletes:      redhat-release-workstation
Recommends:     springdale-release-eula
Requires:	springdale-core
Requires:	springdale-appstream
Source0:        springdale-release-%{base_release_version}.0.tar.gz
Source1:        85-display-manager.preset
Source2:        90-default.preset
Source3:        99-default-disable.preset
#Source4:        redhat-release-productids-9.0-beta-20210727072006.tar.gz
#Source5:        RHEL-%{full_release_version}%{beta_part}-swidtag.tar.gz
Source6:        50-redhat.conf
Source7:        90-default-user.preset

%package rhel
Summary:        Compabitility files to make system look like rhel
Group:          System Environment/Base
Requires:       %{name} = %{version}-%{release}
Requires:       coreutils

%description rhel
Provides compatibility files required to make the system look like
RHEL.

%description
%{product_family} release files

%package eula
Summary:        %{product_family} EULA file
Group:          System Environment/Base
Provides:	redhat-release-eula
License:        Not applicable
%description eula
%{product_family} EULA file

%prep
%setup -q -n springdale-release-%{base_release_version}
#setup -q -n redhat-release-%{base_release_version} -T -D -a 4
#setup -q -n redhat-release-%{base_release_version} -T -D -a 5

%build
echo OK

%install
rm -rf %{buildroot}

# create /etc
mkdir -p %{buildroot}/etc
mkdir -p %{buildroot}/%{_prefix}/lib

# create /etc/system-release and /etc/redhat-release
echo "%{product_family} release %{full_release_version}%{?beta: %{beta}} (%{release_name})" > %{buildroot}/etc/springdale-release
echo "%{product_family_rhel} release %{full_release_version}%{?beta: %{beta}} (%{release_name_rhel})" > %{buildroot}/etc/springdale-release-rhel
#ln -s springdale-release %{buildroot}/etc/system-release

# create /usr/lib/os-release
cat << EOF >>%{buildroot}/%{_prefix}/lib/os-release-springdale
NAME="%{product_family}"
VERSION="%{full_release_version} (%{release_name})"
ID="rhel"
ID_LIKE="fedora"
VERSION_ID="%{full_release_version}"
PLATFORM_ID="platform:el%{base_release_version}"
PRETTY_NAME="%{product_family} %{full_release_version}%{?beta: %{beta}} (%{release_name})"
ANSI_COLOR="0;32"
CPE_NAME="cpe:/o:springdale:enterprise_linux:%{base_release_version}::baseos"
HOME_URL="https://springdale.princeton.edu/"
DOCUMENTATION_URL="https://access.redhat.com/documentation/red_hat_enterprise_linux/%{base_release_version}/"
BUG_REPORT_URL="https://springdale.princeton.edu/bugzilla"

REDHAT_BUGZILLA_PRODUCT="%{product_family} %{base_release_version}"
REDHAT_BUGZILLA_PRODUCT_VERSION=%{full_release_version}
REDHAT_SUPPORT_PRODUCT="%{product_family}"
REDHAT_SUPPORT_PRODUCT_VERSION="%{full_release_version}%{?beta: %{beta}}"
EOF
cat << EOF >>%{buildroot}/%{_prefix}/lib/os-release-rhel
NAME="%{product_family_rhel}"
VERSION="%{full_release_version} (%{release_name_rhel})"
ID="rhel"
ID_LIKE="fedora"
VERSION_ID="%{full_release_version}"
PLATFORM_ID="platform:el%{base_release_version}"
PRETTY_NAME="%{product_family} %{full_release_version}%{?beta: %{beta}} (%{release_name})"
ANSI_COLOR="0;32"
CPE_NAME="cpe:/o:redhat:enterprise_linux:%{base_release_version}::baseos"
HOME_URL="https://springdale.princeton.edu/"
DOCUMENTATION_URL="https://access.redhat.com/documentation/red_hat_enterprise_linux/%{base_release_version}/"
BUG_REPORT_URL="https://springdale.princeton.edu/bugzilla"

REDHAT_BUGZILLA_PRODUCT="%{product_family} %{base_release_version}"
REDHAT_BUGZILLA_PRODUCT_VERSION=%{full_release_version}
REDHAT_SUPPORT_PRODUCT="%{product_family}"
REDHAT_SUPPORT_PRODUCT_VERSION="%{full_release_version}%{?beta: %{beta}}"
EOF

# create /etc/os-release symlink
ln -s ../%{_prefix}/lib/os-release %{buildroot}/%{_sysconfdir}/os-release

# write cpe to /etc/system/release-cpe
echo "cpe:/o:springdale:enterprise_linux:%{base_release_version}::baseos" | tr [A-Z] [a-z] > %{buildroot}/etc/system-release-cpe

# create /etc/issue and /etc/issue.net
echo '\S' > %{buildroot}/etc/issue
echo 'Kernel \r on an \m' >> %{buildroot}/etc/issue
cp %{buildroot}/etc/issue %{buildroot}/etc/issue.net
echo >> %{buildroot}/etc/issue
mkdir -p -m 755 %{buildroot}/etc/issue.d

mkdir -p -m 755 %{buildroot}/etc/pki/rpm-gpg
# Correct GPG keys were fixed in via rhbz#1672230
cp RPM-GPG-KEY-* %{buildroot}/etc/pki/rpm-gpg/
chmod 0644 %{buildroot}/etc/pki/rpm-gpg/RPM-GPG-KEY-*

# Copy Productids
mkdir -p -m 755 %{buildroot}/etc/pki/product-default
#if [ -d redhat-release-productids-%{full_release_version}-*/%{_arch} ]; then
#    for pem in redhat-release-productids-%{full_release_version}-*/%{_arch}/*.pem; do
#        install -m 644 $pem %{buildroot}/etc/pki/product-default
#    done
#fi

## set up the dist tag macros
mkdir -p %{buildroot}%{_rpmmacrodir}
cat > %{buildroot}%{_rpmmacrodir}/macros.dist << EOF
# dist macros.

%%rhel %{base_release_version}
%%__bootstrap         ~bootstrap
%%dist %%{!?distprefix0:%%{?distprefix}}%%{expand:%%{lua:for i=0,9999 do print("%%{?distprefix" .. i .."}") end}}%{dist}%%{?with_bootstrap:%{__bootstrap}}
%%el%{base_release_version} 1
EOF
### dist tag macros end

# make redhat-release a protected package
install -p -d -m 755 %{buildroot}/etc/dnf/protected.d/
touch springdale-release.conf
echo springdale-release > springdale-release.conf
install -p -c -m 0644 springdale-release.conf %{buildroot}/etc/dnf/protected.d/
rm -f springdale-release.conf

# use unbranded datadir
mkdir -p -m 755 %{buildroot}/%{_datadir}/springdale-release
install -m 644 EULA %{buildroot}/%{_datadir}/springdale-release
ln -sf springdale-release %{buildroot}/%{_datadir}/redhat-release

# use unbranded docdir
mkdir -p -m 755 %{buildroot}/%{_docdir}/springdale-release
install -m 644 GPL %{buildroot}/%{_docdir}/springdale-release
ln -s springdale-release %{buildroot}/%{_docdir}/redhat-release

# copy systemd presets
mkdir -p %{buildroot}/%{_prefix}/lib/systemd/system-preset/
mkdir -p %{buildroot}/%{_prefix}/lib/systemd/user-preset
install -m 0644 %{SOURCE1} %{buildroot}/%{_prefix}/lib/systemd/system-preset/
install -m 0644 %{SOURCE2} %{buildroot}/%{_prefix}/lib/systemd/system-preset/
install -m 0644 %{SOURCE3} %{buildroot}/%{_prefix}/lib/systemd/system-preset/

install -m 0644 %{SOURCE7} %{buildroot}%{_prefix}/lib/systemd/user-preset/
install -m 0644 %{SOURCE3} %{buildroot}%{_prefix}/lib/systemd/user-preset/

# copy sysctl presets
mkdir -p %{buildroot}/%{_prefix}/lib/sysctl.d/
install -m 0644 %{SOURCE6} %{buildroot}/%{_prefix}/lib/sysctl.d/

mkdir -p -m 755 %{buildroot}/etc/yum.repos.d

# Copy SWID tags
mkdir -p -m 755 %{buildroot}%{_prefix}/lib/swidtag/
#mkdir -p -m 755 %{buildroot}%{_prefix}/lib/swidtag/%{swid_regid}
#if ! [ %{_arch} = "i386" ] ; then
#    install -p -m 644 RHEL-%{full_release_version}%{beta_part}-swidtag/com.redhat.RHEL-%{base_release_version}-%{_arch}.swidtag %{buildroot}%{_prefix}/lib/swidtag/%{swid_regid}/
#    install -p -m 644 RHEL-%{full_release_version}%{beta_part}-swidtag/com.redhat.RHEL-%{full_release_version}%{beta_part}-%{_arch}.swidtag %{buildroot}%{_prefix}/lib/swidtag/%{swid_regid}/
#fi
mkdir -p -m 755 %{buildroot}/etc/pki/swid/CA/
#mkdir -p -m 755 %{buildroot}/etc/pki/swid/CA/%{swid_regid}
mkdir -p -m 755 %{buildroot}/etc/swid/swidtags.d
#ln -s %{_prefix}/lib/swidtag/%{swid_regid} %{buildroot}/etc/swid/swidtags.d/%{swid_regid}
#install -p -m 644 RHEL-%{full_release_version}%{beta_part}-swidtag/redhatcodesignca.cert %{buildroot}/etc/pki/swid/CA/%{swid_regid}/

# For compatibility
ln -f %{buildroot}/etc/springdale-release %{buildroot}/etc/redhat-release
ln -f %{buildroot}%{_prefix}/lib/os-release-springdale %{buildroot}%{_prefix}/lib/os-release
ln -sf springdale-release %{buildroot}/etc/system-release

%clean
rm -rf %{buildroot}

%post rhel
ln -f /etc/springdale-release-rhel /etc/redhat-release || :
ln -f %{_prefix}/lib/os-release-rhel %{_prefix}/lib/os-release || :
ln -sf redhat-release /etc/system-release || :

%preun rhel
if [ $1 -eq 0 ] ; then 
	ln -f /etc/springdale-release /etc/redhat-release || :
	ln -f %{_prefix}/lib/os-release-springdale %{_prefix}/lib/os-release || :
	ln -sf springdale-release /etc/system-release || :
fi

%files
%defattr(0644,root,root,0755)
/etc/springdale-release
/etc/redhat-release
/etc/system-release
%config /etc/os-release
%config /etc/system-release-cpe
%config(noreplace) /etc/issue
%config(noreplace) /etc/issue.net
%dir /etc/issue.d
/etc/dnf/protected.d/springdale-release.conf
/etc/pki/rpm-gpg/
%{_rpmmacrodir}/macros.dist
%{_docdir}/redhat-release
%{_docdir}/springdale-release/*
%{_prefix}/lib/systemd/system-preset/*
%{_prefix}/lib/systemd/user-preset/*
%{_prefix}/lib/sysctl.d/50-redhat.conf
%{_prefix}/lib/os-release
%{_prefix}/lib/os-release-springdale
/etc/pki/product-default
%dir /etc/yum.repos.d
/etc/swid/swidtags.d
%{_prefix}/lib/swidtag
#%{_prefix}/lib/swidtag/%{swid_regid}
/etc/pki/swid/CA/
#/etc/pki/swid/CA/%{swid_regid}

%files eula
%defattr(0644,root,root,0755)
%{_datadir}/redhat-release
%{_datadir}/springdale-release/EULA

%files rhel
%defattr(0644,root,root,0755)
/etc/springdale-release-rhel
%{_prefix}/lib/os-release-rhel

%changelog
* Mon Sep 13 2021 Djordje Todorovic <dtodorov@redhat.com> - 9.0-1.13
- Version bump to enable IMA signing
- Related: RHELBLD-7394

* Wed Sep 10 2021 Djordje Todorovic <dtodorov@redhat.com> - 9.0-1.12
- Version bump for RHEL 9 Beta IMA sign testing
- Related: RHELBLD-7394

* Wed Sep 01 2021 Aleksandra Fedorova <afedorova@redhat.com> - 9.0-1.11
- Version bump for RHEL 9 Beta branching
- Related: rhbz#2000210

* Mon Aug 02 2021 Stephen Gallagher <sgallagh@redhat.com> - 9.0-1.10
- Fix macros test
- Related: rhbz#1985500

* Mon Aug 02 2021 Stephen Gallagher <sgallagh@redhat.com> - 9.0-1.9
- Move RPM macros to /usr on behalf of Neal Gompa
- Resolves: rhbz#1985500

* Tue Jul 27 2021 Veronika Doubkova - 9.0-1.8.el9
- Updated ProductIDs 
- Resolves: RHELBLD-6794

* Mon Jul 26 2021 Stephen Gallagher <sgallagh@redhat.com> - 9.0-1.7.el9
- Add presets for pipewire services from Neal Gompa
- Related: rhbz#1956854

* Mon Jul 26 2021 Josh Boyer <jwboyer@redhat.com> - 9.0-1.6.el9
- Add preset for SDDM from Neal Gompa
- Resolves: RhBug 1985511
 
* Fri Jul 02 2021 Veronika Doubkova <vdoubkov@redhat.com> - 9.0-1.5.el9
- Enable logrotate.timer 
- Resolves: RHELBLD-6668

* Wed Apr 28 2021 Aviv Sabadra <asabadra@redhat.com> - 9.0-1.4.el9
- Added SWID tags
- Resolves: RHELBLD-1993

* Tue Apr 06 2021 Veronika Doubkova <vdoubkov@redhat.com> - 9.0-1.3.el9
- Modified cpe strings
- Resolves: RHELBLD-5042

* Tue Mar 23 2021 Josh Boyer <jwboyer@redhat.com> - 9.0-1.2.el9
- Add sysctl.d presets
- Resolves: RhBug 1925547

* Wed Mar 10 2021 Veronika Doubkova <vdoubkov@redhat.com> - 9.0-1.1.el9
- Fix typo in changelog 
- Related: RHELBLD-4843

* Wed Mar 10 2021 Veronika Doubkova <vdoubkov@redhat.com> - 9.0-1.0.el9
- Bump release to 1.0 and update the define beta
- Resolves: RHELBLD-4843

* Tue Mar 09 2021 Veronika Doubkova <vdoubkov@redhat.com> - 9.0-0.13.el9
- Enable iscsi service files 
- Resolves: RHELPLAN-69897

* Wed Feb 17 2021 Aviv Sabadra <asabadra@redhat.com> - 9.0-0.12.el9
- Added SHA256 signed productids
- Resolves: RHELBLD-4538

* Wed Jan 06 2021 Stephen Gallagher <sgallagh@redhat.com> - 9.0-0.11.el9
- Include %%__bootstrap macro to support golang packages

* Wed Dec 16 2020 Josh Boyer <jwboyer@redhat.com> - 9.0-0.10.el9
- Adjust PRETTY_NAME
- Start ostree-mount and mlocate-updatedb by default
- Add DOCUMENTATION_URL

* Tue Dec 15 2020 Aviv Sabadra <asabadra@redhat.com> - 9.0-0.9.el9
- Adding productids. RHELBLD-4065

* Thu Dec 10 2020 Petr Šabata <contyk@redhat.com> - 9.0-0.8.el9
- Reverting the dist tag change post-mass rebuild

* Mon Dec 07 2020 Petr Šabata <contyk@redhat.com> - 9.0-0.7.el9.1
- Bump the %%dist tag to el9.1 for the gcc11 mass rebuild

* Tue Nov 17 2020 Troy Dawson<tdawson@redhat.com> - 9.0-0.7.el9
- Add distprefix to %{dist}
- Cleanup old, unneeded comments

* Mon Nov 02 2020 Stephen Gallagher <sgallagh@redhat.com> - 9.0-0.6.el9
- Add platform definition for modules
- Add codename

* Thu Oct 29 2020 Jan Kaluza <jkaluza@redhat.com> - 9.0-0.5.el9
- Enable dbus and dbus-broker by default to fix Anaconda installer.

* Mon Oct 12 2020 Josh Boyer <jwboyer@redhat.com> - 9.0-0.4.el9
- Adjust EULA
- Resolves: rhbz#1886860

* Sun Oct 11 2020 Aviv Sabadra <asabadra@redhat.com> - 9.0-0.3.el9
- Removed tarballs from the repo
- Resolves: RHELBLD-3105

* Tue Oct 06 2020 Aviv Sabadra <asabadra@redhat.com> - 9.0-0.2.el9
- Add RHEL-9.0 Beta product ID certs
- Resolves: RHELBLD-2542

* Tue Jul 07 2020 Djordje Todorovic <dtodorov@redhat.com>
- Rebuild for RHEL-9.0 bootstrapping
